
package com.qihoo.appstore.updatelib;

import org.json.JSONObject;

import android.os.Parcel;
import android.os.Parcelable;

public class AppInfo implements Parcelable {
    /** 是否有新版本 */
    public boolean isNewVersion = false;
    /** 新版本version code */
    public long versionCode = 0;
    /** 新版本version name */
    public String versioName;
    /** 是否为省流量更新 */
    public boolean isPatchUpdate = false;
    /** 应用大小 */
    public long size = 0;
    /** 省流量更新，应用大小 */
    public long patchUpdateSize = 0;
    /** 新功能说明 */
    public String updateComment;
    /** 下载Url */
    public String downloadUrl;
    /** 包名 */
    public String packageName;

    AppInfo() {
    }

    AppInfo(JSONObject json) {
        isNewVersion = json.optBoolean("new_version");
        versionCode = json.optLong("version_code");
        isPatchUpdate = json.optBoolean("save_update");
        size = json.optLong("size");
        patchUpdateSize = json.optLong("save_size");
        updateComment = json.optString("update_txt");
        versioName = json.optString("version_name");
        downloadUrl = json.optString("download_url");
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dst, int flag) {
        dst.writeInt(isNewVersion ? 1 : 0);
        dst.writeLong(versionCode);
        dst.writeInt(isPatchUpdate ? 1 : 0);
        dst.writeLong(size);
        dst.writeLong(patchUpdateSize);
        dst.writeString(updateComment);
        dst.writeString(versioName);
        dst.writeString(downloadUrl);

        dst.writeString(packageName);
    }

    private AppInfo(Parcel source) {
        isNewVersion = source.readInt() == 1;
        versionCode = source.readLong();
        isPatchUpdate = source.readInt() == 1;
        size = source.readLong();
        patchUpdateSize = source.readLong();
        updateComment = source.readString();
        versioName = source.readString();
        downloadUrl = source.readString();

        packageName = source.readString();
    }

    public static final Creator<AppInfo> CREATOR = new Creator<AppInfo>() {
        @Override
        public AppInfo createFromParcel(Parcel source) {
            return new AppInfo(source);
        }

        @Override
        public AppInfo[] newArray(int size) {
            return new AppInfo[size];
        }
    };

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("AppInfo[");
        sb.append("\n\tisNewVersion:").append(isNewVersion);
        sb.append("\n\t,versionCode:").append(versionCode);
        sb.append("\n\t,isPatchUpdate:").append(isPatchUpdate);
        sb.append("\n\t,size:").append(size);
        sb.append("\n\t,patchUpdateSize:").append(patchUpdateSize);
        sb.append("\n\t,updateComment:").append(updateComment);
        sb.append("\n\t,versioName:").append(versioName);
        sb.append("\n\t,downloadUrl:").append(downloadUrl);
        sb.append("\n\t,packageName:").append(packageName);
        sb.append("\n\t]");
        return sb.toString();
    }
}
